//ZahlenGenerator_501d.js
//© 17.04.2018 / Hans Haesler, Châtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Erzeugt eine Spalte von Zahlen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren //////////////////////////
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prüfen, ob ein Dokument geöffnet ist ////////////////////////////////////////////
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}
else {
	curDoc = app.documents[0];
}

// die Arrays mit den Teil-Strings /////////////////////////////////////////////////
oneStrings = ["null", "ein", "zwei", "drei", "vier", "fünf", "sechs", "sieben", "acht", "neun"];
dblStrings = ["", "", "", "", "", "", "", "", "", "", "zehn", "elf", "zwölf", "dreizehn", "vierzehn", "fünfzehn", "sechzehn", "siebzehn", "achtzehn", "neunzehn"];
tenStrings = ["", "zehn", "zwanzig", "dreissig", "vierzig", "fünfzig", "sechzig", "siebzig", "achtzig", "neunzig"];

// den Array der Textrahmen initialisieren
var txtFrameArr = [];

// die Auswahl speichern und prüfen
var nTxtFrames = 0;
curSel = app.selection;

if (curSel.length > 0) {
	for (var s=0; s<curSel.length; s++) {
		var curType = curSel[s].constructor.name;
		if (curType == "TextFrame") {
			txtFrameArr.push(curSel[s]);
		}
		else if (curType == "Group") {
			var allItems = curSel[s].allPageItems;
			for (var n=0; n<allItems.length; n++) {
				var curType = allItems[n].constructor.name;
				if (curType == "TextFrame") {
					txtFrameArr.push(allItems[n]);
				}
			}
		}
		else {
			if (curSel[0].hasOwnProperty("baseline")) {
				txtFrameArr.push(curSel[0].parentTextFrames[0]);
			}
		}
	}
	nTxtFrames = txtFrameArr.length;
	if (nTxtFrames == 0) {
		alert ("Die Auswahl enthält keinen Textrahmen.", "Stop");
		exit();
	}
}
else {
	alert ("Einen leeren Textrahmen auswählen.", "Stop");
	exit();
}

// das Ergebnis prüfen /////////////////////////////////////////////////////////////
if (nTxtFrames > 1) { // wenn mehr als _ein_ Textrahmen gewählt ist
	alert ("Nur *einen* Textrahmen wählen.", "Achtung");
	exit();
}
else if (nTxtFrames == 1) { // wenn nur _ein_ Textrahmen ausgewählt ist
	var curFrame = txtFrameArr[0];
	var curCont  = curFrame.parentStory.contents;
	if (curCont.length == 0) { // wenn der Textrahmen leer ist
		// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
		var defStr = getPrefs();
		// wenn die Vorgabendatei existiert, die Werte ausziehen
		if (defStr != "") {
			repDef = defStr.split("\n");
			stVal = repDef[0]*1;
			ndVal = repDef[1]*1;
			tyDec = repDef[2];
			rb01 = rb02 = 0;
			if (tyDec == "0") {
				rb01 = 1;
			}
			else if (tyDec == "1") {
				rb02 = 1;
			}
			ssDec = repDef[3];
			rb03 = rb04 = 0;
			if (ssDec == "0") {
				rb03 = 1;
			}
			else if (ssDec == "1") {
				rb04 = 1;
			}
			diDec = repDef[4];
			rb05 = rb06 = 0;
			if (diDec == "0") {
				rb05 = 1;
			}
			else if (diDec == "1") {
				rb06 = 1;
			}
			zeDec = repDef[5];
			rb07 = rb08 = 0;
			if (zeDec == "0") {
				rb07 = 1;
			}
			else if (zeDec == "1") {
				rb08 = 1;
			}
			adDec = repDef[6];
			rb09 = rb10 = rb11 = rb12 = 0;
			if (adDec == "0") {
				rb09 = 1;
			}
			else if (adDec == "1") {
				rb10 = 1;
			}
			else if (adDec == "2") {
				rb11 = 1;
			}
			else if (adDec == "3") {
				rb12 = 1;
			}
		}
		else { // wenn keine Vorgabendatei gefunden wurde
			stVal =  1;
			ndVal = 10;
			rb01  =  1;
			rb02  =  0;
			rb03  =  1;
			rb04  =  0;
			rb05  =  1;
			rb06  =  0;
			rb07  =  1;
			rb08  =  0;
			rb09  =  1;
			rb10  =  0;
			rb11  =  0;
			rb12  =  0;
		}
		
		// die Funktion aufrufen, welche die erste und die letzte Zahl usw. erfragt
		var defNumbers = getNumbers();
		var startVal   = defNumbers[0];
		var stopVal    = defNumbers[1];
		var typeDec    = defNumbers[2];
		var ssszDec    = defNumbers[3];
		var direDec    = defNumbers[4];
		var zeroDec    = defNumbers[5];
		var addiDec    = defNumbers[6];
		
		// wenn "sz"
		if (ssszDec == 1) {
			tenStrings[3] = "dreißig";
		}
		
		// einige Prüfungen
		if (typeDec == 0) { // = Worte
			if (startVal < 0 || stopVal < 0) { // = negative Werte
				alert ("Negative Wort-Zahlen sind nicht möglich.", "Stop");
				exit();
			}
		}
		else if (typeDec == 1) { // = Ziffern
			if (zeroDec == 1) {
				if (startVal > -1 && stopVal > -1) {
					var nStart = (""+startVal).length;
					var nStop  = (""+stopVal).length; 
					if (nStart != nStop) {
						if (nStop > nStart) {
							nDiff = nStop-nStart;
						}
						else {
							nDiff = nStart-nStop;
						}
					}
					else {
						zeroDec = 0;
					}
				}
				else {
					var startTmp = startVal;
					if (startVal < 0) {
						startTmp = startVal-(startVal*2);
					}
					var stopTmp  = stopVal;
					if (stopVal < 0) {
						stopTmp = stopVal-(stopVal*2);
					}
					if (startTmp<stopTmp) {
						startTmp = stopTmp;
					}
					var nStart = (""+startTmp).length;
					var nStop  = 1;
					nDiff = nStart-nStop;
				}
			}
			if (addiDec == 2 || addiDec == 3) {
				var minusChar = "–";
			}
			if (startVal < 0 || stopVal < 0) {
				var minusChar = "";
				app.findTextPreferences = app.changeTextPreferences = null;
				app.findTextPreferences.findWhat   = "-";
				app.changeTextPreferences.changeTo = "–";
			}
			if (minusChar == "–") {
				if (direDec == 0) {
					direDec = 1;
				}
				else if (direDec == 1) {
					direDec = 0;
				}
			}
		}
		
		// die Auswahl aufheben
		app.selection = null;
		var numArr = [];
		var ctr = 0;
		// eine Schleife durch die Werte
		if (direDec == 0) { // wenn aufsteigend
			if (typeDec == 0) { // = Worte
				for (var n=startVal; n<stopVal+1; n++) {
					numberText = getNumberText(""+n);
					if (numberText != undefined) {
						numArr[ctr] = numberText;
						ctr++;
					}
				}
				var numStr = numArr.join("\r");
				curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
			}
			else { // = Ziffern
				if (addiDec == 0) { // kein Zusatz
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 1) { // Tabulator voranstellen
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = "\t"+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 2) { // Minuszeichen voranstellen
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 3) { // Tabulator und Minuszeichen davor
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = "\t"+minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4";
							curFrame.parentStory.changeGrep();
						}
					}
				}
			}
		}
		else if (direDec == 1) { // wenn absteigend
			if (typeDec == 0) { // = Worte
				for (var n=stopVal; n>=startVal; n--) {
					numberText = getNumberText(""+n);
					if (numberText != undefined) {
						numArr[ctr] = numberText;
						ctr++;
					}
				}
				var numStr = numArr.join("\r");
				curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
			}
			else { // = Ziffern
				if (addiDec == 0) { // kein Zusatz
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 1) { // Tabulator voranstellen
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = "\t"+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 2) { // Minuszeichen voranstellen
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 3) { // Tabulator und Minuszeichen davor
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = "\t"+minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4";
							curFrame.parentStory.changeGrep();
						}
					}
				}
			}
		}
		if (minusChar == "") {
			curFrame.parentStory.changeText();
		}
		if (zeroDec == 1) {
			curFrame.parentStory.recompose();
		}
	}
	else {
		alert ("Der Textrahmen muss leer sein.", "Stopp");
		exit();
	}
}

// die Suchen/Ersetzen-Preferences zurücksetzen ////////////////////////////////////
app.findTextPreferences = app.changeTextPreferences = null;
app.findGrepPreferences = app.changeGrepPreferences = null;

// das Ende der Aktion verkünden ///////////////////////////////////////////////////
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(444);
// das Fenster schliessen
dlog.close();


/////////////////////////////////////////////////////////////////////////////////////
// die Informationen vorbereiten ////////////////////////////////////////////////////
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthält
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Zahlen_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Zahlen_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// einen Dialog zeigen (erste Zahl, letzte Zahl usw.) //////////////////////////////
function getNumbers() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth1 = 138;
	var labelWidth2 = 104;
	var fieldWidth1 =  64;
	var bttnsWidth1 = 124;
	var aDialog = app.dialogs.add({name:"Zahlen-Spalte in Worten (oder in Ziffern)"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Erste Zahl ", minWidth:labelWidth1});
				var startField = integerEditboxes.add({editValue:stVal, minWidth:fieldWidth1});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Letzte Zahl ", minWidth:labelWidth1});
				var stopField = integerEditboxes.add({editValue:ndVal, minWidth:fieldWidth1});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Sorte ", minWidth:labelWidth2});
						with(typButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" Worte", checkedState:rb01, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" Ziffern", checkedState:rb02});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"\"ss\" oder \"ß\" ", minWidth:labelWidth2});
						with(essButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" dreissig", checkedState:rb03, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" dreißig", checkedState:rb04});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Richtung ", minWidth:labelWidth2});
						with(dirButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" aufsteigend", checkedState:rb05, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" absteigend", checkedState:rb06});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:20});
				staticTexts.add({staticLabel:"Wenn \"Ziffern\" ..."});
				staticTexts.add({staticLabel:" ", minWidth:2});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Führende Nullen", minWidth:labelWidth2});
						with(zerButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" nein", checkedState:rb07, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" ja", checkedState:rb08});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Davorsetzen", minWidth:labelWidth2});
						with(addButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" nichts", checkedState:rb09, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" Tabulator", checkedState:rb10});
							radiobuttonControls.add({staticLabel:" Minuszeichen", checkedState:rb11});
							radiobuttonControls.add({staticLabel:" Tab und Minus", checkedState:rb12});
						}
					}
				}
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"", minWidth:0});
			}
		}

	}
	// den Dialog anzeigen und auswerten
	if(aDialog.show() == true) {
		var startVal = startField.editValue;
		var stopVal  = stopField.editValue;
		var typDec   = typButtns.selectedButton;
		var essDec   = essButtns.selectedButton;
		var dirDec   = dirButtns.selectedButton;
		var zerDec   = zerButtns.selectedButton;
		var addDec   = addButtns.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// die Liste der Einstellungen ...
		var prefsList = new Array(startVal, stopVal, typDec, essDec, dirDec, zerDec, addDec);
		// ... in eine Textkette verwandeln ...
		var curDef = prefsList.join("\n");
		// ... zur Funktion schicken, welche sie in eine Datei schreibt
		writeResult(curDef);
		// das Ergebnis zum Aufruf zurückschicken
		if (startVal<stopVal) {
			return [startVal, stopVal, typDec, essDec, dirDec, zerDec, addDec];
		}
		else {
			return [stopVal, startVal, typDec, essDec, dirDec, zerDec, addDec];
		}
	}
	else {
		aDialog.destroy();
		exit();
	}
}

////////////////////////////////////////////////////////////////////////////////////
// das Ergebnis in eine Datei schreiben ////////////////////////////////////////////
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Zahlen_501.txt");
	}
	else {
		var f = File("~/Library/Preferences/Zahlen_501.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Funktion, welche die Zahlen in Textketten umwandelt /////////////////////////
function getNumberText(nStr) {
	var strLen = nStr.length;
	var numVal = nStr*1;
	if (strLen == 1) {
		if (numVal == 1) {
			return "eins";
		}
		else {
			return (oneStrings[numVal]);
		}
	}
	else if (strLen == 2) {
		if (numVal < 20) {
			return (dblStrings[numVal]);
		}
		else if (numVal > 19) {
			if (nStr[1] == "0") {
				return tenStrings[nStr[0]];
			}
			else {
				return (oneStrings[nStr[1]]) + "und" + (tenStrings[nStr[0]]);
			}
		}
	}
	else if (strLen == 3) {
		var d1 = nStr[0];
		var d2 = nStr[1];
		var d3 = nStr[2];
		if (d2 == 0 && d3 == 0) { // 100
			return (oneStrings[d1]) + "hundert";
		}
		else	if (d2 == 0 && d3 == 1) { // 101 {
			return (oneStrings[d1]) + "hunderteins";
		}
		else if (d2 == 0 && d3 > 1) { // 102, etc.
			return (oneStrings[d1]) + "hundert" + (oneStrings[d3]);
		}
		else if (d2 > 0 && d3 == 0) { // 110, etc.
			return (oneStrings[d1]) + "hundert" + (tenStrings[d2]);
		}
		else if (d2 == 1 && d3 > 0) { // 111, etc.
			return (oneStrings[d1]) + "hundert" + (dblStrings[(d2+d3)]);
		}
		else if (d2 > 1 && d3 > 0) { // 121, etc.
			return (oneStrings[d1]) + "hundert" + (oneStrings[d3] + "und" + (tenStrings[d2]));
		}
	}
	else if (strLen == 4) {
		var d1 = nStr[0];
		var d2 = nStr[1];
		var d3 = nStr[2];
		var d4 = nStr[3];
		if (d2 == 0 && d3 == 0 && d4 == 0) { // 1000
			return (oneStrings[d1] + "tausend");
		}
		else if (d2 == 0 && d3 == 0 && d4 == 1) { // 1001
			return (oneStrings[d1] + "tausendeins");
		}
		else if (d2 == 0 && d3 == 0 && d4 > 1) { // 1002, etc.
			return (oneStrings[d1] + "tausend" + oneStrings[d4]);
		}
		else if (d2 == 0 && d3 > 0 && d4 == 0) { // 1010, etc.
			return (oneStrings[d1] + "tausend" + tenStrings[d3]);
		}
		else if (d2 == 0 && d3 == 1 && d4 > 0) { // 1011, etc.
			return (oneStrings[d1] + "tausend" + dblStrings[d3+d4]);
		}
		else if (d2 == 0 && d3 > 1 && d4 > 0) { // 1021, etc.
			return (oneStrings[d1] + "tausend" + oneStrings[d4]+"und"+tenStrings[d3]);
		}
		else if (d2 > 0 && d3 == 0 && d4 == 0) { // 1100, etc.
			return (oneStrings[d1] + "tausend" + oneStrings[d2] + "hundert");
		}
		else if (d2 > 0 && d3 == 0 && d4 == 1) { // 1101, etc.
			return (oneStrings[d1] + "tausend" + oneStrings[d2] + "hunderteins");
		}
		else if (d2 > 0 && d3 == 0 && d4 > 1) { // 1102, etc. 
			return (oneStrings[d1] + "tausend" + oneStrings[d2] + "hundert" + oneStrings[d4]);
		}
		else if (d2 > 0 && d3 > 0 && d4 == 0) { // 1110, etc.
			return (oneStrings[d1] + "tausend" + oneStrings[d2] + "hundert" + tenStrings[d3]);
		}
		else if (d2 > 0 && d3 == 1 && d4 > 0) { // 1111, etc.
			return (oneStrings[d1] + "tausend" + oneStrings[d2] + "hundert" + dblStrings[d3+d4]);
		}
		else if (d2 > 0 && d3 > 1 && d4 > 0) { // 1121, etc.
			return (oneStrings[d1] + "tausend" + oneStrings[d2] + "hundert" + oneStrings[d4]+"und"+tenStrings[d3]);
		}
	}
	else if (strLen == 5) {
		if (nStr == 10000) {
			return "zehntausend";
		}
		else {
			alert ("Für Zahlen ab 10001 ist das Script noch nicht ausgerüstet.", "Achtung");
			exit();
		}
	}
}